/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package common.timer;

import java.io.Serializable;

/**
 *
 * @author riccardo
 */
public abstract class TimerTask implements Serializable {

    protected final int SECONDS = 1;
    protected final int MINUTES = 60 * SECONDS;
    protected final int HOURS = 60 * MINUTES;

    public static final TimerTask buildTask(Class<? extends TimerTask> taskExecutorClass, Serializable payload) {

        TimerTask task = null;

        try {

            task = taskExecutorClass.newInstance();
            task.init(payload);
        }
        catch (Exception ex) {

            ex.printStackTrace();
        }

        return task;
    }

    protected static final TimerTaskCommand buildTaskCommand(int sleepSecsBefore, Class<? extends TimerTask> taskExecutorClass, Serializable payload) {
        return new TimerTaskCommand(sleepSecsBefore, taskExecutorClass, payload);
    }

    protected static final TimerTaskCommand buildTaskCommand(int sleepSecsBefore, Class<? extends TimerTask> taskExecutorClass) {
        return new TimerTaskCommand(sleepSecsBefore, taskExecutorClass);
    }

    public abstract void execute() throws Exception;

    public abstract void init(Serializable payload);

    public TimerTaskCommand getFirstCommand() {
        return null;
    }

    public TimerTaskCommand getNextCommand(TimerTaskCommand previous) {
        return null;
    }

}
