/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package common.timer;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * @author riccardo
 */
public class TimerTaskCommand implements Serializable {

    private Date whenCreated;
    private int sleepSecsBefore;
    private Serializable payload;
    private Class<? extends TimerTask> taskExecutorClass;

    protected TimerTaskCommand(int sleepSecsBefore, Class<? extends TimerTask> taskExecutorClass, Serializable payload) {
        this.whenCreated = new Date();
        this.sleepSecsBefore = Math.max(sleepSecsBefore, 0);
        this.taskExecutorClass = taskExecutorClass;
        this.payload = payload;
    }
    
    protected TimerTaskCommand(int sleepSecsBefore, Class<? extends TimerTask> taskExecutorClass) {
        this(sleepSecsBefore, taskExecutorClass, null);
    }

    public Date getWhenCreated() {
        return whenCreated;
    }

    public int getSleepSecsBefore() {
        return sleepSecsBefore;
    }

    public Serializable getPayload() {
        return payload;
    }

    public Class<? extends TimerTask> getTaskExecutorClass() {
        return taskExecutorClass;
    }

    @Override
    public String toString() {
        return "TimerTaskCommand [taskExecutorClass="+taskExecutorClass+", payload="+payload+", sleepSecsBefore="+sleepSecsBefore+"]";
    }

}
