/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package common.timer.ejb;

import common.timer.TimerTask;
import common.timer.TimerTaskCommand;
import common.util.ejb.DelegateEjbHelper;
import javax.ejb.TimerHandle;

/**
 *
 * @author mauro
 */
public class TimerSvcDelegate implements TimerSvc {

    public static final String DEFAULT_EJB_NAME = "ejb/TimerSvcEjb";

    private DelegateEjbHelper<TimerSvc> helper;

    public TimerSvcDelegate() {
        helper = new DelegateEjbHelper<TimerSvc>(DEFAULT_EJB_NAME);
    }

    public TimerSvcDelegate(String serverName, int serverPort) {
        helper = new DelegateEjbHelper<TimerSvc>(serverName, serverPort, DEFAULT_EJB_NAME);
    }

    @Override
    public TimerHandle scheduleTask(TimerTask task) {
        return helper.getEjb().scheduleTask(task);
    }

    @Override
    public TimerHandle unscheduleTaskCommand(TimerTaskCommand taskCommand) {
        return helper.getEjb().unscheduleTaskCommand(taskCommand);
    }

    @Override
    public void unscheduleTaskCommand(TimerHandle t) {
        helper.getEjb().unscheduleTaskCommand(t);
    }
}
