/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package common.util.ejb;

import java.util.Hashtable;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author mauro
 */
public class DelegateEjbHelper<T> {

    private T ejb;
    private String ejbName;
    private String initialHost;
    private int initialPort;

    public DelegateEjbHelper(String ejbName) {
        this.ejb = null;
        this.ejbName = ejbName;
        this.initialHost = null;
        this.initialPort = 0;
    }

    public DelegateEjbHelper(String initialHost, int initialPort, String ejbName) {
        this.ejb = null;
        this.ejbName = ejbName;
        this.initialHost = initialHost;
        this.initialPort = initialPort;
    }

    public T getEjb() {
        synchronized(this) {
            if( ejb == null ) {
                ejb = lookup();
            }
        }

        return ejb;
    }

    private T lookup() {
         try {
            InitialContext ic;
            if( initialHost == null || initialHost.length() == 0 ) {
                ic = new InitialContext();
            } else {
                Hashtable<String,String> environment = new Hashtable<String,String>();
                environment.put("org.omg.CORBA.ORBInitialHost", initialHost);
                environment.put("org.omg.CORBA.ORBInitialPort", "" + initialPort);
                ic = new InitialContext(environment);
            }

            return (T) ic.lookup(ejbName);
        } catch (NamingException ex) {
            Logger.getLogger("EjbLazyLookupHelper").log(Level.SEVERE, "Error accessing ejb "+ejbName, ex);
        }

        return null;
    }

}
