/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package test.timer.ejb;

import common.timer.TimerTask;
import common.timer.TimerTaskCommand;
import common.timer.ejb.TimerSvc;
import common.timer.ejb.TimerSvcImpl;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.ejb.*;

/**
 *
 * @author mauro
 */
@Stateless(name="TimerSvcEjb",mappedName="ejb/TimerSvcEjb")
@Remote(TimerSvc.class)
public class TimerSvcBean implements TimerSvc {
    
    public static final String LOGGER_NAME = "TimerSvc";

    @Resource
    private SessionContext sessionCtx;

    private TimerSvcImpl impl;

    @PostConstruct
    public void postConstructInit() {
        impl = new TimerSvcImpl(sessionCtx);
    }

    @PreDestroy
    public void preDestroyDeInit() {
    }

    @Timeout
    public void onTaskTimer(Timer timer) {
        impl.onTaskTimer(timer);
    }

    // ---------------------------------------------------------------------------

    @Override
    public TimerHandle scheduleTask(TimerTask task) {
        return impl.scheduleTask(task);
    }

    @Override
    public TimerHandle unscheduleTaskCommand(TimerTaskCommand taskCommand) {
        return impl.unscheduleTaskCommand(taskCommand);
    }

    @Override
    public void unscheduleTaskCommand(TimerHandle t) {
        impl.unscheduleTaskCommand(t);
    }
}
